#include <genieArduino.h>

int bpmval=0;
int bpmchanged=1;
int running=0;
unsigned long ctime=0;
int outval=0;
int gaugeVal=0;
unsigned long timeinterval=0;
int swingdir=1;

void setup() 
{ 
  genieBegin (GENIE_SERIAL,9600);  //Serial0
  genieAttachEventHandler(EventHandler);

  pinMode(4, OUTPUT);  // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(4, 1);  // Reset the Display via D4
  delay(100);
  digitalWrite(4, 0);  // unReset the Display via D4
  
  delay (3500); //let the display start up
}

void loop() 
{ 
  genieDoEvents();
  if(running) {
    if(swingdir) {
      gaugeVal=(millis()-ctime)*200/timeinterval;
    } else {
      gaugeVal=200-(millis()-ctime)*200/timeinterval; 
    }     
    genieWriteObject(GENIE_OBJ_METER, 0x00, gaugeVal);     
    if(millis()>ctime+timeinterval){
      outval = !outval;
      swingdir = !swingdir;
      digitalWrite(13,outval);
      ctime=ctime+timeinterval;
    }
  }
}

void EventHandler(void) {
  genieFrame Event;
  genieDequeueEvent(&Event);

  //If the cmd received is from a Reported Event
  if(Event.reportObject.cmd == GENIE_REPORT_EVENT) {
    if (Event.reportObject.object == GENIE_OBJ_4DBUTTON) {
      if (Event.reportObject.index == 1) {
        // Start Button
        running=1;
        timeinterval=60000/bpmval;        
        ctime=millis();
      } else if (Event.reportObject.index == 0) {
        // Stop Button
        running=0;
      } else if (Event.reportObject.index == 2) {
        // BPM Increase Button
        bpmval++;
        bpmchanged=1;        
      } else if (Event.reportObject.index == 3) {
        // BPM Decrease Button
        bpmval--;
        bpmchanged=1;
      }
    }
  }
  
  if(bpmchanged) {        
    genieWriteObject(GENIE_OBJ_LED_DIGITS, 0x00, bpmval);     // Write Slider0 value to to LED Digits 0 
    bpmchanged=0;   
  }
}

