//#include <SoftwareSerial.h>
//SoftwareSerial DisplaySerial(2,3); // Using Software Serial

#define DisplaySerial Serial // Using Hardware Serial

#include "Picaso_Serial_4DLib.h"
#include "Picaso_Const4D.h"

Picaso_Serial_4DLib Display(&DisplaySerial);
unsigned long colourvalue = 0;
char tempstring[256] = {0}; // Temporary String Variable for putstr
  
void setup() {
  pinMode(4, OUTPUT);  // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(4, 1);  // Reset the Display via D4
  delay(100);
  digitalWrite(4, 0);  // unReset the Display via D4  
  delay (3500); //let the display start up
  
  DisplaySerial.begin(9600); // Using default 9600 baud rate
  Display.TimeLimit4D = 5000 ; // 5 second timeout on all commands
  Display.gfx_BGcolour(WHITE); // Make it text on white background
  Display.txt_BGcolour(WHITE);
  Display.gfx_ScreenMode(4); // Landscape, microSD Card Facing Up  
  Display.gfx_Cls(); // Clear Screen
}

void loop() {
  Display.gfx_MoveTo(random(0,320),random(0,240));
  colourvalue=random(0,65536);
  Display.txt_FGcolour(colourvalue);
  sprintf(tempstring,"Colour value 0x%04X\n",colourvalue); // Assemble colour value string into tempstring for putstr
  Display.putstr(tempstring);
}
